[CCode (cheader_filename = "valaassignment.h")]
namespace Vala {
	public class Assignment : Vala.Expression {
		public construct  (Vala.Expression _left, Vala.Expression _right, Vala.AssignmentOperator _op = AssignmentOperator.SIMPLE, Vala.SourceReference _source = null);
		public Vala.Expression left { get; set construct; }
		public weak Vala.AssignmentOperator operator { get; set; }
		public Vala.Expression right { get; set construct; }
	}
}
[CCode (cheader_filename = "valaassignment.h")]
namespace Vala {
	public enum AssignmentOperator {
		SIMPLE,
		BITWISE_OR,
		BITWISE_AND,
		BITWISE_XOR,
		ADD,
		SUB,
		MUL,
		DIV,
		PERCENT,
		SHIFT_LEFT,
		SHIFT_RIGHT,
	}
}
[CCode (cheader_filename = "valaattribute.h")]
namespace Vala {
	public class Attribute : Vala.CodeNode {
		public GLib.List<Vala.NamedArgument> args;
		public construct  (string _name, Vala.SourceReference source);
		public void add_argument (Vala.NamedArgument arg);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaattributeprocessor.h")]
namespace Vala {
	public class AttributeProcessor : Vala.CodeVisitor {
		public void process (Vala.CodeContext context);
	}
}
[CCode (cheader_filename = "valabinaryexpression.h")]
namespace Vala {
	public class BinaryExpression : Vala.Expression {
		public construct  (Vala.BinaryOperator op, Vala.Expression _left, Vala.Expression _right, Vala.SourceReference source);
		public weak Vala.BinaryOperator operator { get; set; }
		public Vala.Expression left { get; set construct; }
		public Vala.Expression right { get; set construct; }
	}
}
[CCode (cheader_filename = "valabinaryexpression.h")]
namespace Vala {
	public enum BinaryOperator {
		PLUS,
		MINUS,
		MUL,
		DIV,
		MOD,
		SHIFT_LEFT,
		SHIFT_RIGHT,
		LESS_THAN,
		GREATER_THAN,
		LESS_THAN_OR_EQUAL,
		GREATER_THAN_OR_EQUAL,
		EQUALITY,
		INEQUALITY,
		BITWISE_AND,
		BITWISE_OR,
		BITWISE_XOR,
		AND,
		OR,
	}
}
[CCode (cheader_filename = "valablock.h")]
namespace Vala {
	public class Block : Vala.Statement {
		public construct  (Vala.SourceReference source = null);
		public void add_statement (Vala.Statement stmt);
		public ref GLib.List get_statements ();
		public void add_local_variable (Vala.VariableDeclarator decl);
		public ref GLib.List get_local_variables ();
		public weak bool contains_jump_statement { get; set; }
	}
}
[CCode (cheader_filename = "valabooleanliteral.h")]
namespace Vala {
	public class BooleanLiteral : Vala.Literal {
		public construct  (bool b, Vala.SourceReference source);
		public weak bool value { get; set; }
	}
}
[CCode (cheader_filename = "valabreakstatement.h")]
namespace Vala {
	public class BreakStatement : Vala.Statement {
		public construct  (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "valacallback.h")]
namespace Vala {
	public class Callback : Vala.DataType {
		public construct  (string _name, Vala.TypeReference _return_type, Vala.SourceReference source = null);
		public void add_type_parameter (Vala.TypeParameter p);
		public void add_parameter (Vala.FormalParameter param);
		public ref GLib.List get_parameters ();
		public bool matches_method (Vala.Method m);
		public Vala.TypeReference return_type { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "valacastexpression.h")]
namespace Vala {
	public class CastExpression : Vala.Expression {
		public construct  (Vala.Expression _inner, Vala.TypeReference type, Vala.SourceReference source);
		public Vala.Expression inner { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "valacharacterliteral.h")]
namespace Vala {
	public class CharacterLiteral : Vala.Literal {
		public construct  (string c, Vala.SourceReference source);
		public string value { get; set construct; }
	}
}
[CCode (cheader_filename = "valaclass.h")]
namespace Vala {
	public class Class : Vala.DataType {
		public construct  (string _name, Vala.SourceReference source);
		public void add_base_type (Vala.TypeReference type);
		public ref GLib.List get_base_types ();
		public void add_type_parameter (Vala.TypeParameter p);
		public void add_constant (Vala.Constant c);
		public void add_field (Vala.Field f);
		public ref GLib.List get_fields ();
		public void add_method (Vala.Method m);
		public ref GLib.List get_methods ();
		public void add_property (Vala.Property prop);
		public ref GLib.List get_properties ();
		public void add_signal (Vala.Signal sig);
		public ref GLib.List get_signals ();
		public void set_cname (string cname);
		public void process_attributes ();
		public Vala.Class base_class { get; set; }
		public weak bool is_abstract { get; set; }
		public weak bool has_private_fields { get; }
		public Vala.Method default_construction_method { get; set; }
		public Vala.Constructor constructor { get; set; }
		public Vala.Destructor destructor { get; set; }
	}
}
[CCode (cheader_filename = "valaclassregisterfunction.h")]
namespace Vala {
	public class ClassRegisterFunction : Vala.TypeRegisterFunction {
		public construct  (Vala.Class cl);
		public Vala.Class class_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "valacodecontext.h")]
namespace Vala {
	public class CodeContext {
		public Vala.Symbol get_root ();
		public ref GLib.List get_source_files ();
		public void add_source_file (Vala.SourceFile file);
		public void accept (Vala.CodeVisitor visitor);
		public void find_header_cycles ();
	}
}
[CCode (cheader_filename = "valacodegenerator.h")]
namespace Vala {
	public class CodeGenerator : Vala.CodeVisitor {
		public construct  (bool manage_memory = true);
		public void emit (Vala.CodeContext context);
		public weak bool memory_management { get; set; }
	}
}
[CCode (cheader_filename = "valacodenode.h")]
namespace Vala {
	public abstract class CodeNode {
		public GLib.List<Vala.Attribute> attributes;
		public abstract void accept (Vala.CodeVisitor visitor);
		public Vala.CodeNode parent_node { get; set; }
		public Vala.Symbol symbol { get; set; }
		public Vala.SourceReference source_reference { get; set; }
		public Vala.CCodeNode ccodenode { get; set; }
		public weak bool error { get; set; }
	}
}
[CCode (cheader_filename = "valacodevisitor.h")]
namespace Vala {
	public abstract class CodeVisitor {
		public virtual void visit_begin_source_file (Vala.SourceFile source_file);
		public virtual void visit_end_source_file (Vala.SourceFile source_file);
		public virtual void visit_begin_namespace (Vala.Namespace ns);
		public virtual void visit_end_namespace (Vala.Namespace ns);
		public virtual void visit_begin_class (Vala.Class cl);
		public virtual void visit_end_class (Vala.Class cl);
		public virtual void visit_begin_struct (Vala.Struct st);
		public virtual void visit_end_struct (Vala.Struct st);
		public virtual void visit_begin_interface (Vala.Interface iface);
		public virtual void visit_end_interface (Vala.Interface iface);
		public virtual void visit_begin_enum (Vala.Enum en);
		public virtual void visit_end_enum (Vala.Enum en);
		public virtual void visit_enum_value (Vala.EnumValue ev);
		public virtual void visit_begin_flags (Vala.Flags fl);
		public virtual void visit_end_flags (Vala.Flags fl);
		public virtual void visit_flags_value (Vala.FlagsValue fv);
		public virtual void visit_begin_callback (Vala.Callback cb);
		public virtual void visit_end_callback (Vala.Callback cb);
		public virtual void visit_constant (Vala.Constant c);
		public virtual void visit_field (Vala.Field f);
		public virtual void visit_begin_method (Vala.Method m);
		public virtual void visit_end_method (Vala.Method m);
		public virtual void visit_formal_parameter (Vala.FormalParameter p);
		public virtual void visit_begin_property (Vala.Property prop);
		public virtual void visit_end_property (Vala.Property prop);
		public virtual void visit_begin_property_accessor (Vala.PropertyAccessor acc);
		public virtual void visit_end_property_accessor (Vala.PropertyAccessor acc);
		public virtual void visit_begin_signal (Vala.Signal sig);
		public virtual void visit_end_signal (Vala.Signal sig);
		public virtual void visit_begin_constructor (Vala.Constructor c);
		public virtual void visit_end_constructor (Vala.Constructor c);
		public virtual void visit_begin_destructor (Vala.Destructor d);
		public virtual void visit_end_destructor (Vala.Destructor d);
		public virtual void visit_named_argument (Vala.NamedArgument n);
		public virtual void visit_type_parameter (Vala.TypeParameter p);
		public virtual void visit_namespace_reference (Vala.NamespaceReference ns);
		public virtual void visit_type_reference (Vala.TypeReference type);
		public virtual void visit_begin_block (Vala.Block b);
		public virtual void visit_end_block (Vala.Block b);
		public virtual void visit_empty_statement (Vala.EmptyStatement stmt);
		public virtual void visit_declaration_statement (Vala.DeclarationStatement stmt);
		public virtual void visit_local_variable_declaration (Vala.LocalVariableDeclaration decl);
		public virtual void visit_variable_declarator (Vala.VariableDeclarator decl);
		public virtual void visit_initializer_list (Vala.InitializerList list);
		public virtual void visit_expression_statement (Vala.ExpressionStatement stmt);
		public virtual void visit_if_statement (Vala.IfStatement stmt);
		public virtual void visit_switch_statement (Vala.SwitchStatement stmt);
		public virtual void visit_switch_section (Vala.SwitchSection section);
		public virtual void visit_switch_label (Vala.SwitchLabel label);
		public virtual void visit_while_statement (Vala.WhileStatement stmt);
		public virtual void visit_do_statement (Vala.DoStatement stmt);
		public virtual void visit_for_statement (Vala.ForStatement stmt);
		public virtual void visit_begin_foreach_statement (Vala.ForeachStatement stmt);
		public virtual void visit_end_foreach_statement (Vala.ForeachStatement stmt);
		public virtual void visit_break_statement (Vala.BreakStatement stmt);
		public virtual void visit_continue_statement (Vala.ContinueStatement stmt);
		public virtual void visit_return_statement (Vala.ReturnStatement stmt);
		public virtual void visit_boolean_literal (Vala.BooleanLiteral lit);
		public virtual void visit_character_literal (Vala.CharacterLiteral lit);
		public virtual void visit_integer_literal (Vala.IntegerLiteral lit);
		public virtual void visit_real_literal (Vala.RealLiteral lit);
		public virtual void visit_string_literal (Vala.StringLiteral lit);
		public virtual void visit_null_literal (Vala.NullLiteral lit);
		public virtual void visit_literal_expression (Vala.LiteralExpression expr);
		public virtual void visit_parenthesized_expression (Vala.ParenthesizedExpression expr);
		public virtual void visit_member_access (Vala.MemberAccess expr);
		public virtual void visit_begin_invocation_expression (Vala.InvocationExpression expr);
		public virtual void visit_end_invocation_expression (Vala.InvocationExpression expr);
		public virtual void visit_element_access (Vala.ElementAccess expr);
		public virtual void visit_postfix_expression (Vala.PostfixExpression expr);
		public virtual void visit_begin_object_creation_expression (Vala.ObjectCreationExpression expr);
		public virtual void visit_end_object_creation_expression (Vala.ObjectCreationExpression expr);
		public virtual void visit_typeof_expression (Vala.TypeofExpression expr);
		public virtual void visit_unary_expression (Vala.UnaryExpression expr);
		public virtual void visit_cast_expression (Vala.CastExpression expr);
		public virtual void visit_binary_expression (Vala.BinaryExpression expr);
		public virtual void visit_type_check (Vala.TypeCheck expr);
		public virtual void visit_conditional_expression (Vala.ConditionalExpression expr);
		public virtual void visit_begin_lambda_expression (Vala.LambdaExpression expr);
		public virtual void visit_end_lambda_expression (Vala.LambdaExpression expr);
		public virtual void visit_begin_assignment (Vala.Assignment a);
		public virtual void visit_end_assignment (Vala.Assignment a);
		public virtual void visit_end_full_expression (Vala.Expression expr);
	}
}
[CCode (cheader_filename = "valaconditionalexpression.h")]
namespace Vala {
	public class ConditionalExpression : Vala.Expression {
		public construct  (Vala.Expression cond, Vala.Expression true_expr, Vala.Expression false_expr, Vala.SourceReference source);
		public Vala.Expression condition { get; set construct; }
		public Vala.Expression true_expression { get; set construct; }
		public Vala.Expression false_expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valaconstant.h")]
namespace Vala {
	public class Constant : Vala.CodeNode {
		public construct  (string _name, Vala.TypeReference type, Vala.Expression init, Vala.SourceReference source);
		public string get_cname ();
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
		public Vala.Expression initializer { get; set construct; }
	}
}
[CCode (cheader_filename = "valaconstructor.h")]
namespace Vala {
	public class Constructor : Vala.CodeNode {
		public construct  (Vala.SourceReference source);
		public Vala.Statement body { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "valacontinuestatement.h")]
namespace Vala {
	public class ContinueStatement : Vala.Statement {
		public construct  (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "valadatatype.h")]
namespace Vala {
	public abstract class DataType : Vala.CodeNode {
		public weak Vala.MemberAccessibility access;
		public weak Vala.Namespace @namespace;
		public abstract string get_cname ();
		public virtual bool is_reference_type ();
		public virtual string get_dup_function ();
		public virtual string get_free_function ();
		public virtual bool is_reference_counting ();
		public virtual string get_ref_function ();
		public virtual string get_unref_function ();
		public virtual string get_type_id ();
		public virtual string get_marshaller_type_name ();
		public abstract ref string get_upper_case_cname (string infix);
		public abstract ref string get_lower_case_cname (string infix);
		public virtual ref GLib.List get_cheader_filenames ();
		public void add_cheader_filename (string filename);
		public Vala.Array get_array ();
		public virtual bool is_subtype_of (Vala.DataType t);
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "valadeclarationstatement.h")]
namespace Vala {
	public class DeclarationStatement : Vala.Statement {
		public construct  (Vala.LocalVariableDeclaration decl, Vala.SourceReference source);
		public Vala.LocalVariableDeclaration declaration { get; set construct; }
	}
}
[CCode (cheader_filename = "valadestructor.h")]
namespace Vala {
	public class Destructor : Vala.CodeNode {
		public construct  (Vala.SourceReference source);
		public Vala.Statement body { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "valadostatement.h")]
namespace Vala {
	public class DoStatement : Vala.Statement {
		public construct  (Vala.Statement _body, Vala.Expression cond, Vala.SourceReference source);
		public Vala.Statement body { get; set; }
		public Vala.Expression condition { get; set; }
	}
}
[CCode (cheader_filename = "valaelementaccess.h")]
namespace Vala {
	public class ElementAccess : Vala.Expression {
		public construct  (Vala.Expression _container, Vala.Expression _index, Vala.SourceReference source);
		public Vala.Expression container { get; set; }
		public Vala.Expression index { get; set; }
	}
}
[CCode (cheader_filename = "valaemptystatement.h")]
namespace Vala {
	public class EmptyStatement : Vala.Statement {
		public construct  (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "valaenum.h")]
namespace Vala {
	public class Enum : Vala.DataType {
		public construct  (string _name, Vala.SourceReference source);
		public void add_value (Vala.EnumValue value);
		public string get_cprefix ();
		public void process_attributes ();
	}
}
[CCode (cheader_filename = "valaenumvalue.h")]
namespace Vala {
	public class EnumValue : Vala.CodeNode {
		public construct  (string _name);
		public construct  with_value (string _name, Vala.Expression _value);
		public string get_cname ();
		public string name { get; set construct; }
		public Vala.Expression value { get; set; }
	}
}
[CCode (cheader_filename = "valaexpression.h")]
namespace Vala {
	public abstract class Expression : Vala.CodeNode {
		public GLib.List<Vala.VariableDeclarator> temp_vars;
		public abstract ref string to_string ();
		public Vala.TypeReference static_type { get; set; }
		public Vala.TypeReference expected_type { get; set; }
		public Vala.Symbol symbol_reference { get; set; }
		public weak bool ref_leaked { get; set; }
		public weak bool ref_missing { get; set; }
	}
}
[CCode (cheader_filename = "valaexpressionstatement.h")]
namespace Vala {
	public class ExpressionStatement : Vala.Statement {
		public construct  (Vala.Expression expr, Vala.SourceReference source = null);
		public Vala.Expression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valafield.h")]
namespace Vala {
	public class Field : Vala.CodeNode {
		public weak Vala.MemberAccessibility access;
		public construct  (string _name, Vala.TypeReference type, Vala.Expression init, Vala.SourceReference source);
		public string get_cname ();
		public void process_attributes ();
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
		public Vala.Expression initializer { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "valaflags.h")]
namespace Vala {
	public class Flags : Vala.DataType {
		public construct  (string _name, Vala.SourceReference source);
		public void add_value (Vala.FlagsValue value);
	}
}
[CCode (cheader_filename = "valaflagsvalue.h")]
namespace Vala {
	public class FlagsValue : Vala.CodeNode {
		public construct  (string _name);
		public construct  with_value (string _name, Vala.Expression _value);
		public string get_cname ();
		public string name { get; set construct; }
		public Vala.Expression value { get; set; }
	}
}
[CCode (cheader_filename = "valaforeachstatement.h")]
namespace Vala {
	public class ForeachStatement : Vala.Statement {
		public construct  (Vala.TypeReference type, string id, Vala.Expression col, Vala.Statement _body, Vala.SourceReference source);
		public Vala.TypeReference type_reference { get; set construct; }
		public string variable_name { get; set construct; }
		public Vala.Expression collection { get; set construct; }
		public Vala.Statement body { get; set; }
		public Vala.VariableDeclarator variable_declarator { get; set; }
	}
}
[CCode (cheader_filename = "valaformalparameter.h")]
namespace Vala {
	public class FormalParameter : Vala.CodeNode {
		public construct  (string _name, Vala.TypeReference type, Vala.SourceReference source = null);
		public construct  with_ellipsis (Vala.SourceReference source = null);
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set; }
		public weak bool ellipsis { get; set; }
		public Vala.Expression default_expression { get; set; }
	}
}
[CCode (cheader_filename = "valaforstatement.h")]
namespace Vala {
	public class ForStatement : Vala.Statement {
		public construct  (Vala.Expression cond, Vala.Statement _body, Vala.SourceReference source);
		public void add_initializer (Vala.Expression init);
		public ref GLib.List get_initializer ();
		public void add_iterator (Vala.Expression iter);
		public ref GLib.List get_iterator ();
		public Vala.Expression condition { get; set; }
		public Vala.Statement body { get; set; }
	}
}
[CCode (cheader_filename = "valaifstatement.h")]
namespace Vala {
	public class IfStatement : Vala.Statement {
		public construct  (Vala.Expression cond, Vala.Block true_stmt, Vala.Block false_stmt, Vala.SourceReference source);
		public Vala.Expression condition { get; set construct; }
		public Vala.Block true_statement { get; set construct; }
		public Vala.Block false_statement { get; set construct; }
	}
}
[CCode (cheader_filename = "valainitializerlist.h")]
namespace Vala {
	public class InitializerList : Vala.Expression {
		public void append (Vala.Expression expr);
		public ref GLib.List get_initializers ();
		public construct  (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "valainstancecast.h")]
namespace Vala {
	public class InstanceCast : Vala.CCodeFunctionCall {
		public construct  (Vala.CCodeExpression expr, Vala.DataType type);
		public Vala.DataType type_reference { get; set construct; }
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "valaintegerliteral.h")]
namespace Vala {
	public class IntegerLiteral : Vala.Literal {
		public construct  (string i, Vala.SourceReference source = null);
		public string value { get; set; }
	}
}
[CCode (cheader_filename = "valainterface.h")]
namespace Vala {
	public class Interface : Vala.DataType {
		public construct  (string _name, Vala.SourceReference source);
		public void add_type_parameter (Vala.TypeParameter p);
		public void add_base_type (Vala.TypeReference type);
		public void add_method (Vala.Method m);
		public ref GLib.List get_methods ();
		public void add_property (Vala.Property prop);
		public ref GLib.List get_properties ();
		public void add_signal (Vala.Signal sig);
		public ref GLib.List get_signals ();
		public string get_lower_case_csuffix ();
		public void set_lower_case_csuffix (string csuffix);
	}
}
[CCode (cheader_filename = "valainterfaceregisterfunction.h")]
namespace Vala {
	public class InterfaceRegisterFunction : Vala.TypeRegisterFunction {
		public construct  (Vala.Interface iface);
		public Vala.Interface interface_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "valainterfacewriter.h")]
namespace Vala {
	public class InterfaceWriter : Vala.CodeVisitor {
		public void write_file (Vala.CodeContext context, string filename);
	}
}
[CCode (cheader_filename = "valainvocationexpression.h")]
namespace Vala {
	public class InvocationExpression : Vala.Expression {
		public construct  (Vala.Expression _call, Vala.SourceReference source = null);
		public void add_argument (Vala.Expression arg);
		public ref GLib.List get_argument_list ();
		public Vala.Expression call { get; set construct; }
	}
}
[CCode (cheader_filename = "valalambdaexpression.h")]
namespace Vala {
	public class LambdaExpression : Vala.Expression {
		public construct  (Vala.Expression body, Vala.SourceReference source);
		public construct  with_statement_body (Vala.Block body, Vala.SourceReference source);
		public void add_parameter (string param);
		public ref GLib.List get_parameters ();
		public Vala.Expression expression_body { get; set; }
		public Vala.Block statement_body { get; set; }
		public Vala.Method method { get; set; }
	}
}
[CCode (cheader_filename = "valaliteral.h")]
namespace Vala {
	public abstract class Literal : Vala.CodeNode {
		public abstract ref string to_string ();
		public Vala.TypeReference static_type { get; set; }
	}
}
[CCode (cheader_filename = "valaliteralexpression.h")]
namespace Vala {
	public class LiteralExpression : Vala.Expression {
		public construct  (Vala.Literal _literal, Vala.SourceReference source = null);
		public Vala.Literal literal { get; construct; }
	}
}
[CCode (cheader_filename = "valalocalvariabledeclaration.h")]
namespace Vala {
	public class LocalVariableDeclaration : Vala.CodeNode {
		public construct  (Vala.TypeReference type, Vala.SourceReference source);
		public construct  var_type (Vala.SourceReference source);
		public void add_declarator (Vala.VariableDeclarator declarator);
		public ref GLib.List get_variable_declarators ();
		public Vala.TypeReference type_reference { get; set; }
	}
}
[CCode (cheader_filename = "valamemberaccess.h")]
namespace Vala {
	public class MemberAccess : Vala.Expression {
		public construct  (Vala.Expression _inner, string member, Vala.SourceReference source = null);
		public construct  simple (string member, Vala.SourceReference source = null);
		public void add_type_argument (Vala.TypeReference arg);
		public ref GLib.List get_type_arguments ();
		public Vala.Expression inner { get; set; }
		public string member_name { get; set construct; }
	}
}
[CCode (cheader_filename = "valamemberaccessibility.h")]
namespace Vala {
	public enum MemberAccessibility {
		PRIVATE,
		INTERNAL,
		PUBLIC,
	}
}
[CCode (cheader_filename = "valamemorymanager.h")]
namespace Vala {
	public class MemoryManager : Vala.CodeVisitor {
		public void analyze (Vala.CodeContext context);
	}
}
[CCode (cheader_filename = "valamethod.h")]
namespace Vala {
	public class Method : Vala.CodeNode {
		public weak Vala.MemberAccessibility access;
		public construct  (string _name, Vala.TypeReference _return_type, Vala.SourceReference source = null);
		public void add_parameter (Vala.FormalParameter param);
		public ref GLib.List get_parameters ();
		public string get_cname ();
		public ref string get_real_cname ();
		public void process_attributes ();
		public bool equals (Vala.Method m2);
		public string name { get; set; }
		public Vala.TypeReference return_type { get; set; }
		public Vala.Block body { get; set; }
		public weak bool instance { get; set; }
		public weak bool is_abstract { get; set; }
		public weak bool is_virtual { get; set; }
		public weak bool overrides { get; set; }
		public weak bool construction { get; set; }
		public weak int n_construction_params { get; set; }
		public weak bool returns_modified_pointer { get; set; }
		public weak bool instance_last { get; set; }
		public weak Vala.Method base_method { get; set; }
		public Vala.FormalParameter this_parameter { get; set; }
	}
}
[CCode (cheader_filename = "valanamedargument.h")]
namespace Vala {
	public class NamedArgument : Vala.CodeNode {
		public construct  (string _name, Vala.Expression arg, Vala.SourceReference source);
		public string name { get; set construct; }
		public Vala.Expression argument { get; set construct; }
	}
}
[CCode (cheader_filename = "valanamespace.h")]
namespace Vala {
	public class Namespace : Vala.CodeNode {
		public construct  (string _name, Vala.SourceReference source);
		public void add_class (Vala.Class cl);
		public void add_interface (Vala.Interface iface);
		public void add_struct (Vala.Struct st);
		public void add_enum (Vala.Enum en);
		public void add_flags (Vala.Flags fl);
		public void add_callback (Vala.Callback cb);
		public ref GLib.List get_structs ();
		public ref GLib.List get_classes ();
		public void add_field (Vala.Field f);
		public void add_method (Vala.Method m);
		public static ref string camel_case_to_lower_case (string camel_case);
		public string get_cprefix ();
		public string get_lower_case_cprefix ();
		public ref GLib.List get_cheader_filenames ();
		public void process_attributes ();
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "valanamespacereference.h")]
namespace Vala {
	public class NamespaceReference : Vala.CodeNode {
		public construct  (string _name, Vala.SourceReference source);
		public string name { get; set construct; }
		public weak Vala.Symbol namespace_symbol { get; set; }
	}
}
[CCode (cheader_filename = "valanullliteral.h")]
namespace Vala {
	public class NullLiteral : Vala.Literal {
		public construct  (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "valaobjectcreationexpression.h")]
namespace Vala {
	public class ObjectCreationExpression : Vala.Expression {
		public construct  (Vala.MemberAccess name, Vala.SourceReference source);
		public void add_argument (Vala.Expression arg);
		public ref GLib.List get_argument_list ();
		public Vala.TypeReference type_reference { get; set; }
		public Vala.Method constructor { get; set; }
		public Vala.MemberAccess member_name { get; set; }
	}
}
[CCode (cheader_filename = "valaparenthesizedexpression.h")]
namespace Vala {
	public class ParenthesizedExpression : Vala.Expression {
		public construct  (Vala.Expression _inner, Vala.SourceReference source);
		public Vala.Expression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "valaparser.h")]
namespace Vala {
	public class Parser : Vala.CodeVisitor {
		public void parse (Vala.CodeContext context);
		public void push_comment (string comment_item, bool file_comment);
		public ref string pop_comment ();
		public void parse_file (Vala.SourceFile source_file);
	}
}
[CCode (cheader_filename = "valapostfixexpression.h")]
namespace Vala {
	public class PostfixExpression : Vala.Expression {
		public construct  (Vala.Expression _inner, bool inc, Vala.SourceReference source);
		public Vala.Expression inner { get; set construct; }
		public weak bool increment { get; set; }
	}
}
[CCode (cheader_filename = "valapropertyaccessor.h")]
namespace Vala {
	public class PropertyAccessor : Vala.CodeNode {
		public construct  (bool _readable, bool _writable, bool _construction, Vala.Statement _body, Vala.SourceReference source);
		public weak bool readable { get; set; }
		public weak bool writable { get; set; }
		public weak bool construction { get; set; }
		public Vala.Statement body { get; set; }
		public Vala.FormalParameter value_parameter { get; set; }
	}
}
[CCode (cheader_filename = "valaproperty.h")]
namespace Vala {
	public class Property : Vala.CodeNode {
		public construct  (string _name, Vala.TypeReference type, Vala.PropertyAccessor _get_accessor, Vala.PropertyAccessor _set_accessor, Vala.SourceReference source);
		public ref string get_upper_case_cname ();
		public ref Vala.CCodeConstant get_canonical_cconstant ();
		public void process_attributes ();
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
		public Vala.PropertyAccessor get_accessor { get; set; }
		public Vala.PropertyAccessor set_accessor { get; set; }
		public weak Vala.MemberAccessibility access { get; set; }
		public Vala.FormalParameter this_parameter { get; set; }
		public weak bool no_accessor_method { get; set; }
	}
}
[CCode (cheader_filename = "valarealliteral.h")]
namespace Vala {
	public class RealLiteral : Vala.Literal {
		public construct  (string r, Vala.SourceReference source);
		public string value { get; set; }
	}
}
[CCode (cheader_filename = "valareport.h")]
namespace Vala {
	public class Report {
		public static int get_warnings ();
		public static int get_errors ();
		public static void warning (Vala.SourceReference source, string message);
		public static void error (Vala.SourceReference source, string message);
	}
}
[CCode (cheader_filename = "valareturnstatement.h")]
namespace Vala {
	public class ReturnStatement : Vala.Statement {
		public construct  (Vala.Expression result = null, Vala.SourceReference source = null);
		public Vala.Expression return_expression { get; set; }
	}
}
[CCode (cheader_filename = "valasemanticanalyzer.h")]
namespace Vala {
	public class SemanticAnalyzer : Vala.CodeVisitor {
		public construct  (bool manage_memory = true);
		public void analyze (Vala.CodeContext context);
		public weak bool memory_management { get; set; }
	}
}
[CCode (cheader_filename = "valasignal.h")]
namespace Vala {
	public class Signal : Vala.CodeNode {
		public weak Vala.MemberAccessibility access;
		public construct  (string _name, Vala.TypeReference _return_type, Vala.SourceReference source);
		public void add_parameter (Vala.FormalParameter param);
		public ref GLib.List get_parameters ();
		public Vala.Callback get_callback ();
		public string name { get; set construct; }
		public Vala.TypeReference return_type { get; set construct; }
	}
}
[CCode (cheader_filename = "valasourcefile.h")]
namespace Vala {
	public class SourceFile {
		public construct  (string _filename, bool _pkg = false);
		public void add_using_directive (Vala.NamespaceReference ns);
		public ref GLib.List get_using_directives ();
		public void add_namespace (Vala.Namespace ns);
		public Vala.Namespace get_global_namespace ();
		public ref GLib.List get_namespaces ();
		public void accept (Vala.CodeVisitor visitor);
		public string get_cheader_filename ();
		public string get_csource_filename ();
		public void add_symbol_dependency (Vala.Symbol sym, Vala.SourceFileDependencyType dep_type);
		public GLib.List get_header_external_includes ();
		public void add_header_internal_include (string include);
		public GLib.List get_header_internal_includes ();
		public GLib.List get_source_external_includes ();
		public GLib.List get_source_internal_includes ();
		public GLib.List get_header_internal_full_dependencies ();
		public GLib.List get_header_internal_dependencies ();
		public string filename { get; set construct; }
		public string comment { get; set; }
		public weak bool pkg { get; set; }
		public Vala.SourceFileCycle cycle { get; set; }
		public weak bool is_cycle_head { get; set; }
		public weak int mark { get; set; }
	}
}
[CCode (cheader_filename = "valasourcefile.h")]
namespace Vala {
	public enum SourceFileDependencyType {
		HEADER_FULL,
		HEADER_SHALLOW,
		SOURCE,
	}
}
[CCode (cheader_filename = "valasourcefilecycle.h")]
namespace Vala {
	public class SourceFileCycle {
		public GLib.List<weak Vala.SourceFile> files;
		public weak Vala.SourceFile head;
	}
}
[CCode (cheader_filename = "valasourcereference.h")]
namespace Vala {
	public class SourceReference {
		public construct  (Vala.SourceFile _file, int _first_line = 0, int _first_column = 0, int _last_line = 0, int _last_column = 0);
		public construct  with_comment (Vala.SourceFile _file, int _first_line, int _first_column, int _last_line, int _last_column, string _comment);
		public ref string to_string ();
		public weak Vala.SourceFile file { get; set; }
		public weak int first_line { get; set; }
		public weak int first_column { get; set; }
		public weak int last_line { get; set; }
		public weak int last_column { get; set; }
		public string comment { get; set; }
	}
}
[CCode (cheader_filename = "valastatement.h")]
namespace Vala {
	public abstract class Statement : Vala.CodeNode {
		public virtual int get_number_of_set_construction_parameters ();
		public weak bool construction { get; set; }
	}
}
[CCode (cheader_filename = "valastringliteral.h")]
namespace Vala {
	public class StringLiteral : Vala.Literal {
		public construct  (string s, Vala.SourceReference source);
		public ref string eval ();
		public string value { get; set; }
	}
}
[CCode (cheader_filename = "valastruct.h")]
namespace Vala {
	public class Struct : Vala.DataType {
		public construct  (string _name, Vala.SourceReference source);
		public void add_type_parameter (Vala.TypeParameter p);
		public void add_constant (Vala.Constant c);
		public void add_field (Vala.Field f);
		public ref GLib.List get_fields ();
		public void add_method (Vala.Method m);
		public ref GLib.List get_methods ();
		public void process_attributes ();
		public void set_dup_function (string name);
		public Vala.Method default_construction_method { get; set; }
	}
}
[CCode (cheader_filename = "valaswitchlabel.h")]
namespace Vala {
	public class SwitchLabel : Vala.CodeNode {
		public construct  (Vala.Expression expr, Vala.SourceReference source = null);
		public construct  with_default (Vala.SourceReference source = null);
		public Vala.Expression expression { get; set; }
	}
}
[CCode (cheader_filename = "valaswitchsection.h")]
namespace Vala {
	public class SwitchSection : Vala.CodeNode {
		public construct  (Vala.SourceReference source);
		public void add_label (Vala.SwitchLabel label);
		public ref GLib.List get_labels ();
		public void add_statement (Vala.Statement stmt);
	}
}
[CCode (cheader_filename = "valaswitchstatement.h")]
namespace Vala {
	public class SwitchStatement : Vala.Statement {
		public construct  (Vala.Expression expr, Vala.SourceReference source);
		public void add_section (Vala.SwitchSection section);
		public Vala.Expression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valasymbolbuilder.h")]
namespace Vala {
	public class SymbolBuilder : Vala.CodeVisitor {
		public void build (Vala.CodeContext context);
	}
}
[CCode (cheader_filename = "valasymbol.h")]
namespace Vala {
	public class Symbol {
		public construct  (Vala.CodeNode _node = null);
		public ref string get_full_name ();
		public void add (string name, Vala.Symbol sym);
		public Vala.Symbol lookup (string name);
		public weak Vala.CodeNode node { get; set; }
		public weak Vala.Symbol parent_symbol { get; set; }
		public string name { get; set; }
		public weak bool active { get; set; }
	}
}
[CCode (cheader_filename = "valasymbolresolver.h")]
namespace Vala {
	public class SymbolResolver : Vala.CodeVisitor {
		public void resolve (Vala.CodeContext context);
	}
}
[CCode (cheader_filename = "valatypecheck.h")]
namespace Vala {
	public class TypeCheck : Vala.Expression {
		public construct  (Vala.Expression expr, Vala.TypeReference type, Vala.SourceReference source);
		public Vala.Expression expression { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "valatypeofexpression.h")]
namespace Vala {
	public class TypeofExpression : Vala.Expression {
		public construct  (Vala.TypeReference type, Vala.SourceReference source);
		public Vala.TypeReference type_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "valatypeparameter.h")]
namespace Vala {
	public class TypeParameter : Vala.CodeNode {
		public weak Vala.DataType type;
		public construct  (string _name, Vala.SourceReference source);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "valatypereference.h")]
namespace Vala {
	public class TypeReference : Vala.CodeNode {
		public construct  ();
		public construct  from_name (string ns, string type, Vala.SourceReference source);
		public static ref Vala.TypeReference new_from_expression (Vala.Expression expr, Vala.SourceReference source);
		public void add_type_argument (Vala.TypeReference arg);
		public ref GLib.List get_type_arguments ();
		public ref string get_cname (bool var_type = false);
		public ref string get_const_cname ();
		public ref string to_string ();
		public ref Vala.TypeReference copy ();
		public bool equals (Vala.TypeReference type2);
		public bool stricter (Vala.TypeReference type2);
		public weak bool reference_to_value_type { get; set; }
		public weak bool transfers_ownership { get; set; }
		public weak bool takes_ownership { get; set; }
		public weak bool is_out { get; set; }
		public weak bool non_null { get; set; }
		public weak Vala.DataType data_type { get; set; }
		public Vala.TypeParameter type_parameter { get; set; }
		public weak bool floating_reference { get; set; }
		public string namespace_name { get; set; }
		public string type_name { get; set; }
		public weak bool array { get; set; }
		public weak bool is_ref { get; set; }
		public weak bool is_weak { get; set; }
	}
}
[CCode (cheader_filename = "valatyperegisterfunction.h")]
namespace Vala {
	public abstract class TypeRegisterFunction : Vala.CCodeFunction {
		public void init_from_type ();
		public abstract Vala.DataType get_type_declaration ();
		public abstract ref string get_type_struct_name ();
		public abstract ref string get_class_init_func_name ();
		public abstract ref string get_instance_struct_size ();
		public abstract ref string get_instance_init_func_name ();
		public abstract ref string get_parent_type_name ();
		public virtual string get_type_flags ();
		public abstract ref Vala.CCodeFragment get_type_interface_init_statements ();
		public ref Vala.CCodeFunction get_declaration ();
	}
}
[CCode (cheader_filename = "valaunaryexpression.h")]
namespace Vala {
	public class UnaryExpression : Vala.Expression {
		public construct  (Vala.UnaryOperator op, Vala.Expression _inner, Vala.SourceReference source);
		public weak Vala.UnaryOperator operator { get; set; }
		public Vala.Expression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "valaunaryexpression.h")]
namespace Vala {
	public enum UnaryOperator {
		PLUS,
		MINUS,
		LOGICAL_NEGATION,
		BITWISE_COMPLEMENT,
		INCREMENT,
		DECREMENT,
		REF,
		OUT,
	}
}
[CCode (cheader_filename = "valavariabledeclarator.h")]
namespace Vala {
	public class VariableDeclarator : Vala.CodeNode {
		public construct  (string _name, Vala.Expression init = null, Vala.SourceReference source = null);
		public string name { get; set construct; }
		public Vala.Expression initializer { get; set; }
		public Vala.TypeReference type_reference { get; set; }
	}
}
[CCode (cheader_filename = "valawhilestatement.h")]
namespace Vala {
	public class WhileStatement : Vala.Statement {
		public construct  (Vala.Expression cond, Vala.Statement _body, Vala.SourceReference source);
		public Vala.Expression condition { get; set; }
		public Vala.Statement body { get; set; }
	}
}
[CCode (cheader_filename = "valaarray.h")]
namespace Vala {
	public class Array : Vala.DataType {
		public construct  (Vala.DataType type);
		public Vala.DataType element_type { get; set construct; }
	}
}
